<template>
  <b-container>
    <GoBack />
  </b-container>
  <b-container>
    <div class="background_bloc" />
    <h1 class="title">
      Modifier produit
    </h1>
  </b-container>
  <b-container>
    <div class="d-flex justify-content-between">
      <h2>Informations</h2>
      <div class="button d-flex justify-content-end">
        <button
          class="submit btn-cta bg-danger text-white"
          text-variant="white"
          type="submit"
          @click.prevent="modalDeleteProduct()"
        >
          Supprimer
        </button>
      </div> 
    </div>
    <b-form>
      <b-form-group>
        <label for="select-cat">Catégorie :</label>
        <select
          id="select-cat"
          v-model="selectedCategories"
          class="form-select"
        >
          <option
            v-for="cat in categories"
            :key="cat"
            :value="'/api/categories/' + cat.id"
          >
            {{ cat.nom }}
          </option>       
        </select>
      </b-form-group>
      <b-form-group
        label="Titre :"
        label-for="input-titre"
      >
        <b-form-input
          id="input-titre"
          v-model="titre"
          type="text"
          required
        />
      </b-form-group>
      <b-form-group
        label="Description :"
        label-for="input-desc"
      >
        <b-form-input
          id="input-desc"
          v-model="description"
          type="text"
          required
        />
      </b-form-group>
      <div class="d-flex">
        <b-form-group
          label="Prix :"
          label-for="input-prix"
          class="w-100"
        >
          <b-form-input
            id="input-prix"
            v-model="prix"
            type="number"
            required
          />
        </b-form-group>
        <b-form-group
          label="Quantité :"
          label-for="input-quantite"
          class="w-100"
        >
          <b-form-input
            id="input-quantite"
            v-model="quantite"
            type="number"
            required
          />
        </b-form-group>
      </div>
      <b-form-checkbox
        v-model="afficher"
        class="mb-2 mr-sm-2 mb-sm-0"
      >
        Afficher le produit
      </b-form-checkbox>
      <div class="button d-flex justify-content-end">
        <button
          class="submit btn-cta"
          type="submit"
          @click.prevent="updateProduct()"
        >
          Enregistrer
        </button>
      </div>
    </b-form>
    <h2>Images</h2>
    <b-form>
      <b-form-group>
        <div
          v-for="(img, index) in produitImg"
          :key="img"
        >
          <img 
            :src="url + img"
            class="vendeur__img m-2"
          >
          <label for="imgDelete">Image {{ index + 1 }} :</label>
          <input
            id="imgDelete"
            type="file"
            name="imgDelete"
            accept="image/png, image/jpeg"
            :data-url="img"
            @change="onFileUpload($event)"
          >
        </div>
        <div v-if="nbInputNewImg">
          <div
            v-for="(input, index) in nbInputNewImg"
            :key="input"
          >
            <label for="newImg">Image {{ index + (1 + 3 - nbInputNewImg) }} :</label>
            <input
              id="newImg"
              type="file"
              name="newImgs"
              accept="image/png, image/jpeg"
              @change="onFileUpload($event)"
            >
          </div>   
        </div>
      </b-form-group>
      <div class="button d-flex justify-content-end">
        <button
          class="submit btn-cta"
          type="submit"
          @click.prevent="updateFile($event)"
        >
          Enregistrer
        </button>
      </div> 
    </b-form>
  </b-container>
  <Modal
    ref="modalMsg"
    :message="message"
    :choix="true"
    :action-btn="deleteProduit"
  />
</template>

<script>
import axios from 'axios';
import Modal from '@/components/Modal.vue';
import GoBack from '@/components/GoBack.vue';

export default {

    components: {
      Modal,
      GoBack
    },
    
    data() {

      return {
        produit: [],
        produitImg: [],
        url: process.env.VUE_APP_URL,
        titre: '',
        description: '',
        quantite: '',
        prix: '',
        selectedCategories: '',
        categories: [],
        afficher: '',
        message: '',
        nbInputNewImg: '',
        arrFile: [],
        arrFileToDelete: [],
      }

    },

    mounted() {
      
        const idProduit = this.$route.params.id;
        
        axios({
            method: 'get',
            url: this.url + "/api/produits/" + idProduit,
        })
        .then(res =>  {
            this.produit = res.data;
            this.afficher = this.produit.afficher;
            this.titre = this.produit.titre;
            this.description = this.produit.description;
            this.quantite = this.produit.quantite;
            this.prix = this.produit.prix;
            this.selectedCategories = this.produit.categorie;            
            if(res.data.mediaObjects[0] != undefined && res.data.mediaObjects[0] != ''){
                res.data.mediaObjects.forEach(media => {
                this.produitImg.push(media.contentUrl);     
              });
              if(this.produitImg.length < 3){
                this.nbInputNewImg = 3 - this.produitImg.length;
              }
            } else {
                this.nbInputNewImg = 3;
            }
        })
        .catch(err => {
            console.log(err);
        })

        // on récupère les catégories de produit
        axios.get(this.url + "/api/categories")          
                    .then(response => {
                        if(response.data['hydra:member'].length > 0){
                            response.data['hydra:member'].forEach(cat => {
                                this.categories.push(cat);
                                })
                        }
                    })
                    .catch(err => console.log(err))

    },

    methods: {
        onFileUpload(event) {
            // si on veut supprimer l'image 
            if(event.target.id == 'imgDelete'){
                let pathImgToDelete = event.target.getAttribute('data-url');
                let imgToDelete = pathImgToDelete.split('/');
                this.arrFileToDelete.push(imgToDelete[2]);
                console.log(this.arrFileToDelete);
            } else {
                this.arrFile.push(event.target.files[0]);
            }
        },

        updateFile(){
            if(this.arrFileToDelete.length > 0){
                for (let i = 0; i < this.arrFileToDelete.length; i++) {
                    const filePath = this.arrFileToDelete[i];
                    axios.delete(this.url + "/api/media_objects/delete/" + filePath)
                    .then(response => {
                        console.log(response.data);
                    })    
                    .catch(err => {
                        console.log(err);
                    })
                }
            }
            if(this.arrFile.length > 0){
                this.arrFile.forEach(file => {
                    axios.post(this.url + "/api/media_objects", {
                        "produit_id": this.$route.params.id,
                        "file": file,
                    },
                    {
                        headers: {
                                "Content-Type": "multipart/form-data"
                        }
                    })          
                   .then(response => {
                    console.log(response.data)
                   })
                   .catch(err => console.log(err))
                });
            }
        },

        updateProduct(){
            axios.put(this.url + "/api/produits/" +this.$route.params.id, {
                "categorie": this.selectedCategories,
                "titre": this.titre,
                "description": this.description,
                "prix": this.prix,
                "afficher": this.afficher,
                "quantite": this.quantite,
            })
            .then(response => {
                this.message = 'Votre produit a bien été modifié'
                this.$refs.modalMsg.show = true;
            })    
            .catch(err => {
                console.log(err);
            })
        },

        modalDeleteProduct(){
            this.message = 'Êtes-vous certain·e de vouloir supprimer définitivement ce produit ?';
            this.$refs.modalMsg.show = true;
        }
    }
  }
</script>
